//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnitEdit.h"
#include "MainUnit.h"
#include "Constant.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TUnitEditForm *UnitEditForm;
//---------------------------------------------------------------------------
__fastcall TUnitEditForm::TUnitEditForm(TComponent* Owner)
    : TForm(Owner)
{
    // R{{bNX̐ݒ
    ComboBox1->Items->Add("");
    ComboBox1->Items->AddStrings(MainForm->mUnitNameList);
    // GAR{{bNX̐ݒ
    ComboBox7->Items = MainForm->mAreaNameList;
    // ړR{{bNX̐ݒ
    ComboBox8->Items = MainForm->mAreaNameList;
    // 
    for (int i = 0; i < 3; i++) {
        ComboBox4->Items->Add(PilotAffiliationStr[i]);
    }
    // 
    for (int i = 0; i < 5; i++) {
        ComboBox5->Items->Add(PilotConditionStr[i]);
    }
    // K
    ComboBox6->Items = MainForm->mClassList;

}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::FormActivate(TObject *Sender)
{
    // GfB^ANeBuɂȂ

    // GfB^̃ANeBu^uݒ
    switch (MainForm->PageControl1->ActivePageIndex) {
        case 0:
            TabControl1->TabIndex = 0;
            break;
        case 1:
            TabControl1->TabIndex = 1;
            break;
        case 2:
            TabControl1->TabIndex = 2;
            break;
        default:
            TabControl1->TabIndex = 0;
            // MainForm ̃ANeBu^uݒ
            MainForm->PageControl1->ActivePageIndex = TabControl1->TabIndex;
    }

    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);

    // No̐ݒ
    int theUnitNo = theGridPtr->Row - 1;
    if (UpDown1->Associate == 0) {
        UpDown1->Position = theUnitNo;
        UpDown1->Associate = Edit1;
    }
    Edit1->Text = theUnitNo;
    // ڐ惁j[ݒ
    UnitEmbarkationMenuSet();
    // pCbgj[̐ݒ
    PilotNameMenuSet();
    // No̕ύX
    Edit1Change(this);

}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::TabControl1Change(TObject *Sender)
{
    const TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);
    // GfB^̐͂ύXꂽ

    // MainForm ̃ANeBu^uݒ
    MainForm->PageControl1->ActivePageIndex = TabControl1->TabIndex;

    // No̐ݒ
    Edit1->Text = theGridPtr->Row - 1;
    // ڐ惁j[ݒ
    UnitEmbarkationMenuSet();
    // pCbgj[̐ݒ
    PilotNameMenuSet();
    // No̕ύX
    Edit1Change(this);
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Edit1Change(TObject *Sender)
{
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);
    // NoύXꂽ

    int theUnitNo;      // No

    theUnitNo = Edit1->Text.ToIntDef(-1);
    if (0 <= theUnitNo && theUnitNo <= 199) {
        // MainForm ̑Isݒ
        theGridPtr->Row = theUnitNo + 1;
        // f[^̓ǂݏo
        UnitControlRefresh();
        // pCbgf[^̓ǂݏo
        PilotControlRefresh();
        // GAf[^̓ǂݏo
        AreaControlRefresh();
    }

    // ڐ惁j[ݒ
    UnitEmbarkationMenuSet();
    // pCbgj[̐ݒ
    PilotNameMenuSet();
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::ComboBox1Change(TObject *Sender)
{
    // ύX
    int theUnitID = ComboBox1->ItemIndex - 1;
    if (CheckBox1->Checked && 0 <= theUnitID && theUnitID < MainForm->mUnitNameList->Count){
        UnitEnduranceMax(theUnitID);
        UnitSupplyMax(theUnitID);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button2Click(TObject *Sender)
{
    // ϋvő
    int theUnitID = ComboBox1->ItemIndex - 1;
    if (0 <= theUnitID && theUnitID < MainForm->mUnitNameList->Count){
        UnitEnduranceMax(theUnitID);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button3Click(TObject *Sender)
{
    // ő
    int theUnitID = ComboBox1->ItemIndex - 1;
    if (0 <= theUnitID && theUnitID < MainForm->mUnitNameList->Count){
        UnitSupplyMax(theUnitID);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::CheckBox2Click(TObject *Sender)
{
    // ڐ惁j[ݒ
    UnitEmbarkationMenuSet();

}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::ComboBox2Change(TObject *Sender)
{
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);
    // ڐύX
    int theIndex = ComboBox2->ItemIndex;
    int theUnitNo = -1;
    int theValue;
    if (0 == theIndex) {
        // ڒ
        theUnitNo = Edit1->Text.ToIntDef(-1);
        if (theGridPtr->Cells[11][theUnitNo + 1] == "1") {
            // ڒ
            theUnitNo = theGridPtr->Cells[12][theUnitNo + 1].ToIntDef(-1);
        }
    } else if (0 < theIndex) {
        // ڒ
        theUnitNo = ComboBoxTextToNumber(ComboBox2->Text);
    }
    AreaDataGet(theUnitNo);
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::ComboBox3Change(TObject *Sender)
{
    // pCbgύX
    int theIndex = ComboBox3->ItemIndex;
    int thePilotID = -1;
    if (0 < theIndex) {
        thePilotID = ComboBoxTextToNumber(ComboBox3->Text);
    }
    PilotDataGet(thePilotID);
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::CheckBox4Click(TObject *Sender)
{
    // pCbgj[ݒ
    PilotNameMenuSet();
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button1Click(TObject *Sender)
{
    // 햼̌
    DropDownMenuFind(ComboBox1, Edit2->Text);
    // ϋvC̕ύX
    int theUnitID = ComboBox1->ItemIndex - 1;
    if (CheckBox1->Checked && 0 <= theUnitID && theUnitID < MainForm->mUnitNameList->Count){
        UnitEnduranceMax(theUnitID);
        UnitSupplyMax(theUnitID);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button4Click(TObject *Sender)
{
    // ڐ̌
    DropDownMenuFind(ComboBox2, Edit7->Text);
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button5Click(TObject *Sender)
{
    // pCbǧ
    DropDownMenuFind(ComboBox3, Edit8->Text);
    // pCbgf[^ύX
    int theIndex = ComboBox3->ItemIndex;
    int thePilotID = -1;
    if (0 < theIndex) {
        thePilotID = ComboBoxTextToNumber(ComboBox3->Text);
    }
    PilotDataGet(thePilotID);
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button6Click(TObject *Sender)
{
    // GǍ
    DropDownMenuFind(ComboBox7, Edit11->Text);

}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button7Click(TObject *Sender)
{
    // ړGǍ
    DropDownMenuFind(ComboBox8, Edit12->Text);

}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::Button8Click(TObject *Sender)
{
    // 
    // GfB^̒l`FbN
    if (CheckControlData()) {
        // f[^ύX
        UnitGridDataSet();
        // pCbg\ύX
        PilotGridDataSet();
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::UnitControlRefresh()
{
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);

    int theUnitNo;      // No
    int theUnitIndex;   // ID
    int theValue;
    AnsiString theStr;

    // 
    ComboBox2->ItemIndex = -1;  // ڐ
    ComboBox2->Text = "";

    theUnitNo = Edit1->Text.ToIntDef(-1);
    if (0 <= theUnitNo && theUnitNo < 200) {
        theUnitNo += 1;
        // O
        theValue = theGridPtr->Cells[1][theUnitNo].ToIntDef(-1);
        if (0 <= theValue && theValue < MainForm->mUnitNameList->Count) {
            ComboBox1->ItemIndex = theValue + 1;
        } else {
            ComboBox1->ItemIndex = 0;
        }
        // ϋv
        Edit3->Text = theGridPtr->Cells[3][theUnitNo];
        // 
        Edit4->Text = theGridPtr->Cells[4][theUnitNo];
        // J
        Edit5->Text = theGridPtr->Cells[5][theUnitNo];
        // mC
        Edit6->Text = theGridPtr->Cells[6][theUnitNo];
        // ڐ
        theValue = theGridPtr->Cells[11][theUnitNo].ToIntDef(0);
        if (theValue == 1) {
            // ڒ̎
            theValue = theGridPtr->Cells[12][theUnitNo].ToIntDef(-1);
            if (0 <= theValue && theValue < 200) {
                // ڐ敔No 
                theUnitIndex = theGridPtr->Cells[1][theValue + 1].ToIntDef(-1);
                if (0 <= theUnitIndex && theUnitIndex < MainForm->mUnitNameList->Count) {
                    theStr = AnsiString(theValue) + " - " + MainForm->mUnitNameList->Strings[theUnitIndex];
                    theValue = ComboBox2->Items->IndexOf(theStr);
                    ComboBox2->ItemIndex = theValue;
                    if (theValue == -1) {
                        ComboBox2->Text = theStr;
                    }
                }
            }
        } else {
            ComboBox2->ItemIndex = 0;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::PilotControlRefresh()
{
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);

    int theUnitNo;      // No
    int thePilotID;     // pCbgID
    int theIndex;

    // pCbg
    theUnitNo = Edit1->Text.ToIntDef(-1);
    if (0 <= theUnitNo && theUnitNo < 200) {
        theUnitNo += 1;
        thePilotID = theGridPtr->Cells[7][theUnitNo].ToIntDef(-1);
        if (0 <= thePilotID && thePilotID < MainForm->mPilotNameList->Count) {
            thePilotID;
            // O
            theIndex = ComboBox3->Items->IndexOf(MainForm->mPilotNameList->Strings[thePilotID]);
            ComboBox3->ItemIndex = theIndex;
            if (theIndex == -1) {
                ComboBox3->Text = MainForm->mPilotNameList->Strings[thePilotID];
            }
            // pCbgf[^
            PilotDataGet(thePilotID);
        } else {
            ComboBox3->ItemIndex = 0;   // O
            PilotDataGet(-1);           // pCbgf[^
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::AreaControlRefresh()
{
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);

    int theUnitNo;  // No
    int theValue;
    // GA
    theValue = Edit1->Text.ToIntDef(-1);
    if (0 <= theValue && theValue < 200) {
        theUnitNo = theValue;
        if (theGridPtr->Cells[11][theUnitNo + 1] == "1") {
            // ڒ̏ꍇ
            theValue = theGridPtr->Cells[12][theUnitNo + 1].ToIntDef(-1);
            if (0 <= theValue && theValue < 200) {
                theUnitNo = theValue;
            }
        }
        AreaDataGet(theUnitNo);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::UnitEnduranceMax(int UnitID)
{
    // ϋvőlɐݒ
    Edit3->Text = MainForm->GetUnitEndurance(UnitID);
}

//---------------------------------------------------------------------------
void __fastcall TUnitEditForm::UnitSupplyMax(int UnitID)
{
    // őlɐݒ
    Edit4->Text = MainForm->GetUnitSupply(UnitID);
}

//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::UnitEmbarkationMenuSet()
{
    // ڐhbv_Eڂ̐ݒ
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);

    // ύXO̕L
    AnsiString theStr = ComboBox2->Text;

    ComboBox2->Clear();
    ComboBox2->Items->Add("");

    int theArea;        // I𒆕̃GAID
    int theUnitID;      // ID
    int theUnitNo;      // No
    int theUnitArea;    // ݒn
    int theValue;

    // I𒆕̃GAID
    theArea = -1;
    theValue = Edit1->Text.ToIntDef(-1);
    if (0 <= theValue && theValue < 200) {
        // I𒆕No
        if (theGridPtr->Cells[11][theValue + 1] == "0") {
            // ڒłȂꍇ
            theArea = theGridPtr->Cells[9][theValue + 1].ToIntDef(-1);
        } else {
            // ڒ̏ꍇ
            theUnitNo = theGridPtr->Cells[12][theValue + 1].ToIntDef(-1);
            if (0 <= theUnitNo && theUnitNo < 200) {
                // ڐ敔No
                theArea = theGridPtr->Cells[9][theUnitNo + 1].ToIntDef(-1);
            }
        }
    }
    if (theArea < 0 || MainForm->mAreaNameList->Count <= theArea) {
        theArea = -1;
    }

    // ڐR{{bNXڂ̐ݒ
    for (int i = 0; i < 200; i++) {
        theUnitID = theGridPtr->Cells[1][i + 1].ToIntDef(-1);
        if (0 <= theUnitID && theUnitID < MainForm->mUnitNameList->Count) {
            AnsiString theUnitName = AnsiString(i) + " - " + MainForm->mUnitNameList->Strings[theUnitID];
            if (theStr != theUnitName) {
                // ډ\݂̂̏ꍇ
                if (CheckBox2->Checked && 0 >= MainForm->GetUnitEmbarkation(theUnitID)) {
                    continue;
                }
                // GÂ݂̏̕ꍇ
                theUnitArea = -1;
                if (theGridPtr->Cells[11][i + 1] == "0") {
                    // ڒłȂꍇ
                    theUnitArea = theGridPtr->Cells[9][i + 1].ToIntDef(-1);
                } else {
                    // ڒ̏ꍇ
                    theValue = theGridPtr->Cells[12][i + 1].ToIntDef(-1);
                    if (0 <= theValue && theValue < 200) {
                        // ڐ敔No
                        theUnitArea = theGridPtr->Cells[9][theValue + 1].ToIntDef(-1);
                    }
                }
                if (theUnitArea < 0 || MainForm->mAreaNameList->Count <= theUnitArea) {
                    theUnitArea = -1;
                }
                if (CheckBox3->Checked && theArea != -1 && theUnitArea != -1 && theArea != theUnitArea) {
                    continue;
                }
            }
            ComboBox2->Items->Add(theUnitName);
        }
    }

    // ύXO̕
    theValue = ComboBox2->Items->IndexOf(theStr);
    ComboBox2->ItemIndex = theValue;
    if (theValue == -1) {
        ComboBox2->Text = theStr;
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::PilotNameMenuSet()
{
    // pCbghbv_Eڂ̐ݒ
    TStringGrid *const theGridPtr = MainForm->StringGrid4_1;

    // ύXO̕L
    AnsiString theStr = ComboBox3->Text;

    ComboBox3->Clear();
    ComboBox3->Items->Add("");
    for (int i = 0; i < MainForm->mPilotNameList->Count; i++) {
        if (theStr != MainForm->mPilotNameList->Strings[i]) {
            if (CheckBox4->Checked && theGridPtr->Cells[4][i + 1] != TabControl1->TabIndex) {
                continue;
            }
            if (CheckBox5->Checked && theGridPtr->Cells[6][i + 1] != 0) {
                continue;
            }
            if (CheckBox6->Checked && theGridPtr->Cells[3][i + 1] != 0) {
                continue;
            }
        }
        ComboBox3->Items->Add(MainForm->mPilotNameList->Strings[i]);
    }

    // ύXO̕
    int theIndex = ComboBox3->Items->IndexOf(theStr);
    ComboBox3->ItemIndex = theIndex;
    if (theIndex == -1) {
        ComboBox3->Text = theStr;
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::PilotDataGet(int PilotID)
{
    // pCbgf[^
    TStringGrid *const theGridPtr = MainForm->StringGrid4_1;

    int theValue;

    ComboBox4->ItemIndex = -1;  // 
    ComboBox4->Text = "";
    ComboBox5->ItemIndex = -1;  // 
    ComboBox5->Text = "";
    ComboBox6->ItemIndex = -1;  // K
    ComboBox6->Text = "";
    Edit9->Clear();             // 
    Edit10->Clear();            // o

    if (0 <= PilotID && PilotID < MainForm->mPilotNameList->Count) {
        PilotID += 1;
        // 
        theValue = theGridPtr->Cells[4][PilotID].ToIntDef(-1);
        if (0 <= theValue && theValue < 3) {
            ComboBox4->ItemIndex = theValue;
        }
        // 
        theValue = theGridPtr->Cells[6][PilotID].ToIntDef(-1);
        if (0 <= theValue && theValue < 5) {
            ComboBox5->ItemIndex = theValue;
        }
        // K
        theValue = theGridPtr->Cells[8][PilotID].ToIntDef(-1);
        if (0 <= theValue && theValue < MainForm->mClassList->Count) {
            ComboBox6->ItemIndex = theValue;
        }
        // 
        Edit9->Text = theGridPtr->Cells[10][PilotID];
        // o
        Edit10->Text = theGridPtr->Cells[11][PilotID];
    }

}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::AreaDataGet(int UnitNo)
{
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);
    // GAf[^
    int theArea = -1;       // GAID
    int theMoveArea = -1;   // ړGAID
    int theMoveType = -1;   // ړ@
    if (0 <= UnitNo && UnitNo < 200) {
        UnitNo += 1;
        theArea = theGridPtr->Cells[9][UnitNo].ToIntDef(-1);                    // ݒn
        theMoveArea = theGridPtr->Cells[14][UnitNo].ToIntDef(-1);               // ړ
        theMoveType = ComboBox9->Items->IndexOf(theGridPtr->Cells[13][UnitNo]); //ړ@

    }
    if (theArea < 0 || MainForm->mAreaNameList->Count <= theArea) {
        theArea = -1;
    }
    if (theMoveArea < 0 || MainForm->mAreaNameList->Count <= theMoveArea) {
        theMoveArea = -1;
    }
    if (theMoveType == -1) {
    theMoveType = 0;
    }
    ComboBox7->ItemIndex = theArea;         // ݒn
    ComboBox8->ItemIndex = theMoveArea;     // ړ
    ComboBox9->ItemIndex = theMoveType;     // ړ@
}
//---------------------------------------------------------------------------

bool __fastcall TUnitEditForm::CheckControlData()
{
    int theUnitNo = Edit1->Text.ToIntDef(-1);
    if (theUnitNo < 0 || 200 <= theUnitNo) {
        MessageDlg("No͈͊Oł", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox1->ItemIndex == -1) {
        MessageDlg("햼ُł\nXgIĂ", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    } else if (ComboBox1->ItemIndex == 0) {
        Edit3->Text = "0";
        Edit4->Text = "0";
        Edit5->Text = "0";
        Edit6->Text = "0";
        ComboBox2->ItemIndex = 0;
        ComboBox3->ItemIndex = 0;
        PilotDataGet(-1);
        return true;
    }
    if (Edit3->Text.ToIntDef(-1) < 0 || Edit4->Text.ToIntDef(-1) < 0 || Edit5->Text.ToIntDef(-1) < 0 || Edit6->Text.ToIntDef(-1) < 0) {
        MessageDlg("ϋvCCJCmCɂ͐l͂Ă", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox2->ItemIndex == -1) {
        MessageDlg("ڐ悪ُł\nXgIĂ", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox3->ItemIndex == -1) {
        MessageDlg("pCbgُł\nXgIĂ", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox3->ItemIndex != 0 && (ComboBox4->ItemIndex == -1 || ComboBox5->ItemIndex == -1 || ComboBox6->ItemIndex == -1)) {
        MessageDlg("CԁCKُł\nXgIĂ", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox3->ItemIndex != 0 && (Edit9->Text.ToIntDef(-1) < 0 || Edit10->Text.ToIntDef(-1) < 0)) {
        MessageDlg("сCoɂ͐l͂Ă", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox2->ItemIndex == 0 && ComboBox7->ItemIndex == -1) {
        MessageDlg("ݒnُł\nXgIĂ", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox2->ItemIndex == 0 && ComboBox9->ItemIndex != 0 && ComboBox8->ItemIndex == -1) {
        MessageDlg("ړ悪ُł\nXgIĂ", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    if (ComboBox2->ItemIndex == 0 && ComboBox9->ItemIndex == -1) {
        MessageDlg("ړ@ُł\nXgIĂ", mtError, TMsgDlgButtons() << mbOK, 0);
        return false;
    }
    return true;
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::UnitGridDataSet()
{
    TStringGrid *const theGridPtr = FindUnitGrid(TabControl1->TabIndex);
    const int theUnitRow = Edit1->Text.ToIntDef(-1) + 1;
    // f[^\ύX

    // OCϋvCCJCmC
    int theUnitID = ComboBoxTextToNumber(ComboBox1->Text);
    if (theUnitID < 0) {
        // 햼̎
        theGridPtr->Cells[1][theUnitRow] = 511;
        theGridPtr->Cells[2][theUnitRow] = "";
    } else {
        theGridPtr->Cells[1][theUnitRow] = theUnitID;
        theGridPtr->Cells[2][theUnitRow] = MainForm->mUnitNameList->Strings[theUnitID];
    }
    theGridPtr->Cells[3][theUnitRow] = Edit3->Text.ToIntDef(0);
    theGridPtr->Cells[4][theUnitRow] = Edit4->Text.ToIntDef(0);
    theGridPtr->Cells[5][theUnitRow] = Edit5->Text.ToIntDef(0);
    theGridPtr->Cells[6][theUnitRow] = Edit6->Text.ToIntDef(0);
    // ڐCGA
    if (ComboBox2->ItemIndex == 0) {
        // ݒn
        int theAreaID = ComboBoxTextToNumber(ComboBox7->Text);
        theGridPtr->Cells[9][theUnitRow] = theAreaID;
        theGridPtr->Cells[10][theUnitRow] = MainForm->mAreaNameList->Strings[theAreaID];
        // ڐ
        theGridPtr->Cells[11][theUnitRow] = 0;
        theGridPtr->Cells[12][theUnitRow] = 0;
        // ړ
        int theMoveAreaID = ComboBoxTextToNumber(ComboBox8->Text);
        theGridPtr->Cells[13][theUnitRow] = (ComboBox9->ItemIndex == 0 ? AnsiString() : ComboBox9->Text);
        theGridPtr->Cells[14][theUnitRow] = theMoveAreaID;
        theGridPtr->Cells[15][theUnitRow] = MainForm->mAreaNameList->Strings[theMoveAreaID];
    } else {
        // ݒn
        theGridPtr->Cells[9][theUnitRow] = 127;
        theGridPtr->Cells[10][theUnitRow] = "";
        // ڐ
        theGridPtr->Cells[11][theUnitRow] = 1;
        theGridPtr->Cells[12][theUnitRow] = ComboBoxTextToNumber(ComboBox2->Text);
        // ړ
        theGridPtr->Cells[13][theUnitRow] = "";
        theGridPtr->Cells[14][theUnitRow] = 0;
        theGridPtr->Cells[15][theUnitRow] = MainForm->mAreaNameList->Strings[0];
    }
    // pCbg
    int thePilotID;
    TStringGrid * theUnitGridPtr;
    if (ComboBox3->ItemIndex != 0) {
        // zL̎
        thePilotID = ComboBoxTextToNumber(ComboBox3->Text);
        for (int i = 0; i < 3; i++) {
            theUnitGridPtr = FindUnitGrid(i);
            for (int j = 1; j <=200; j++) {
                // zς݂̕
                if (theUnitGridPtr->Cells[7][j] == thePilotID) {
                    theUnitGridPtr->Cells[7][j] = "255";
                    theUnitGridPtr->Cells[8][j] = "";
                }
            }
        }
        // z
        theGridPtr->Cells[7][theUnitRow] = thePilotID;
        theGridPtr->Cells[8][theUnitRow] = MainForm->mPilotNameList->Strings[thePilotID];

    } else {
        // z̎
        theGridPtr->Cells[7][theUnitRow] = 255;
        theGridPtr->Cells[8][theUnitRow] = "";
    }
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::PilotGridDataSet()
{
    TStringGrid *const theGridPtr = MainForm->StringGrid4_1;
    // pCbg\ύX
    if (ComboBox3->ItemIndex > 0) {
        int thePilotRow = ComboBoxTextToNumber(ComboBox3->Text) + 1;

        theGridPtr->Cells[1][thePilotRow] = 127;                        // GAID
        theGridPtr->Cells[2][thePilotRow] = "";                         // GA
        theGridPtr->Cells[3][thePilotRow] = 1;                          // 
        theGridPtr->Cells[4][thePilotRow] = ComboBox4->ItemIndex;       // ID
        theGridPtr->Cells[5][thePilotRow] = ComboBox4->Text;            // 
        theGridPtr->Cells[6][thePilotRow] = ComboBox5->ItemIndex;       // ID
        theGridPtr->Cells[7][thePilotRow] = ComboBox5->Text;            // 
        theGridPtr->Cells[8][thePilotRow] = ComboBox6->ItemIndex;       // KID
        theGridPtr->Cells[9][thePilotRow] = ComboBox6->Text;            // K
        theGridPtr->Cells[10][thePilotRow] = Edit9->Text.ToIntDef(0);   // 
        theGridPtr->Cells[11][thePilotRow] = Edit10->Text.ToIntDef(0);  // o
    }
    // ԂύX
    for (int i = 1; i <= MainForm->mPilotNameList->Count; i++) {
        theGridPtr->Cells[3][i] = 0;  // 
    }
    TStringGrid * theUnitGridPtr;
    int theUnitID;
    int thePilotID;
    for (int i = 0; i < 3; i++) {
        theUnitGridPtr = FindUnitGrid(i);
        for (int j = 1; j <= 200; j++) {
            theUnitID = theUnitGridPtr->Cells[1][j].ToIntDef(-1);
            thePilotID = theUnitGridPtr->Cells[7][j].ToIntDef(-1);
            if (0 < theUnitID && theUnitID < MainForm->mUnitNameList->Count &&
                0 < thePilotID && thePilotID < MainForm->mPlanNameList->Count) {
                theGridPtr->Cells[3][thePilotID + 1] = 1;  // 
            }
        }
    }

}
//---------------------------------------------------------------------------

TStringGrid * __fastcall TUnitEditForm::FindUnitGrid(int index)
{
    switch (index) {
        case 0:
            return MainForm->StringGrid1_2;
        case 1:
            return MainForm->StringGrid2_2;
        case 2:
            return MainForm->StringGrid3_2;
    }
    return 0;
}
//---------------------------------------------------------------------------

void __fastcall TUnitEditForm::DropDownMenuFind(TComboBox *const control, const AnsiString &string)
{
    // hbv_Ej
    int theIndex = control->ItemIndex;

    for (int i = theIndex + 1; ; i++){
        // Ōz
        if (i >= control->Items->Count) {
            i = 0;
        }
        // Ȃ
        if (i == theIndex) {
            break;
        }
        // 
        if (control->Items->Strings[i].AnsiPos(string) != 0) {
            control->ItemIndex = i;
            break;
        }
    }
}
//---------------------------------------------------------------------------

int __fastcall  TUnitEditForm::ComboBoxTextToNumber(const AnsiString &string)
{
    int thePos = string.AnsiPos(" ");
    AnsiString theStr = string.SubString(0, thePos - 1);
    return theStr.ToIntDef(-1);
}
//---------------------------------------------------------------------------

